"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _chalk() {
  const data = _interopRequireDefault(require("chalk"));

  _chalk = function () {
    return data;
  };

  return data;
}

function _pickBy() {
  const data = _interopRequireDefault(require("lodash/pickBy"));

  _pickBy = function () {
    return data;
  };

  return data;
}

function _get() {
  const data = _interopRequireDefault(require("lodash/get"));

  _get = function () {
    return data;
  };

  return data;
}

function _xdl() {
  const data = require("@expo/xdl");

  _xdl = function () {
    return data;
  };

  return data;
}

function _terminalLink() {
  const data = _interopRequireDefault(require("terminal-link"));

  _terminalLink = function () {
    return data;
  };

  return data;
}

function _BaseBuilder() {
  const data = _interopRequireDefault(require("../BaseBuilder"));

  _BaseBuilder = function () {
    return data;
  };

  return data;
}

function _constants() {
  const data = require("../constants");

  _constants = function () {
    return data;
  };

  return data;
}

function utils() {
  const data = _interopRequireWildcard(require("../utils"));

  utils = function () {
    return data;
  };

  return data;
}

function apple() {
  const data = _interopRequireWildcard(require("../../../appleApi"));

  apple = function () {
    return data;
  };

  return data;
}

function _prompt() {
  const data = _interopRequireDefault(require("../../../prompt"));

  _prompt = function () {
    return data;
  };

  return data;
}

function _image() {
  const data = require("./utils/image");

  _image = function () {
    return data;
  };

  return data;
}

function _route() {
  const data = require("../../../credentials/route");

  _route = function () {
    return data;
  };

  return data;
}

function _context() {
  const data = require("../../../credentials/context");

  _context = function () {
    return data;
  };

  return data;
}

function _list() {
  const data = require("../../../credentials/actions/list");

  _list = function () {
    return data;
  };

  return data;
}

function _SetupIosDist() {
  const data = require("../../../credentials/views/SetupIosDist");

  _SetupIosDist = function () {
    return data;
  };

  return data;
}

function _SetupIosPush() {
  const data = require("../../../credentials/views/SetupIosPush");

  _SetupIosPush = function () {
    return data;
  };

  return data;
}

function _SetupIosProvisioningProfile() {
  const data = require("../../../credentials/views/SetupIosProvisioningProfile");

  _SetupIosProvisioningProfile = function () {
    return data;
  };

  return data;
}

function _CommandError() {
  const data = _interopRequireWildcard(require("../../../CommandError"));

  _CommandError = function () {
    return data;
  };

  return data;
}

function _log() {
  const data = _interopRequireDefault(require("../../../log"));

  _log = function () {
    return data;
  };

  return data;
}

function _IosDistCert() {
  const data = require("../../../credentials/views/IosDistCert");

  _IosDistCert = function () {
    return data;
  };

  return data;
}

function _IosPushCredentials() {
  const data = require("../../../credentials/views/IosPushCredentials");

  _IosPushCredentials = function () {
    return data;
  };

  return data;
}

function _IosProvisioningProfile() {
  const data = require("../../../credentials/views/IosProvisioningProfile");

  _IosProvisioningProfile = function () {
    return data;
  };

  return data;
}

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class IOSBuilder extends _BaseBuilder().default {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "appleCtx", void 0);
  }

  async run() {
    await this.validateProject();
    await this.checkForBuildInProgress();

    if (this.options.type === 'archive') {
      await this.prepareCredentials();
    }

    const publishedExpIds = await this.ensureProjectIsPublished();

    if (!this.options.publicUrl) {
      await this.checkStatusBeforeBuild();
    }

    await this.build(publishedExpIds);
  }

  async validateProject() {
    const bundleIdentifier = (0, _get().default)(this.manifest, 'ios.bundleIdentifier');
    const sdkVersion = this.manifest.sdkVersion;
    await this.validateIcon();

    if (!bundleIdentifier) {
      throw new (_xdl().XDLError)('INVALID_OPTIONS', `Your project must have a bundleIdentifier set in app.json.
See https://docs.expo.io/versions/latest/distribution/building-standalone-apps/#2-configure-appjson`);
    }

    await utils().checkIfSdkIsSupported(sdkVersion, _constants().PLATFORMS.IOS);
  }

  async getAppleCtx() {
    if (!this.appleCtx) {
      await apple().setup();
      this.appleCtx = await apple().authenticate(this.options);
    }

    return this.appleCtx;
  } // Try to get the user to provide Apple credentials upfront
  // We will be able to do full validation of their iOS creds this way


  async bestEffortAppleCtx(ctx, bundleIdentifier) {
    if (this.options.appleId) {
      return await ctx.ensureAppleCtx(this.options);
    }

    const nonInteractive = this.options.parent && this.options.parent.nonInteractive;

    if (nonInteractive) {
      return null;
    }

    const {
      confirm
    } = await (0, _prompt().default)([{
      type: 'confirm',
      name: 'confirm',
      message: `Do you have access to the Apple account that will be used for submitting this app to the App Store?`
    }]);

    if (confirm) {
      return await ctx.ensureAppleCtx(this.options);
    } else {
      (0, _log().default)(_chalk().default.green('No problem! 👌 \nWe can’t auto-generate credentials if you don’t have access to the main Apple account. \nBut we can still set it up if you upload your credentials.'));
    }
  }

  async prepareCredentials() {
    var _this$manifest$owner, _this$user;

    // TODO: Fix forcing the username to be valid
    const username = (_this$manifest$owner = this.manifest.owner) !== null && _this$manifest$owner !== void 0 ? _this$manifest$owner : (_this$user = this.user) === null || _this$user === void 0 ? void 0 : _this$user.username;
    const experienceName = `@${username}/${this.manifest.slug}`;
    const bundleIdentifier = (0, _get().default)(this.manifest, 'ios.bundleIdentifier');
    const context = new (_context().Context)();
    await context.init(this.projectDir);
    await this.bestEffortAppleCtx(context, bundleIdentifier);
    await this.clearAndRevokeCredentialsIfRequested(context, {
      experienceName,
      bundleIdentifier
    });

    try {
      if (this.options.skipCredentialsCheck) {
        (0, _log().default)('Skipping credentials check...');
        return;
      }

      await this.produceCredentials(context, experienceName, bundleIdentifier);
    } catch (e) {
      if (e.code === _CommandError().ErrorCodes.NON_INTERACTIVE) {
        _log().default.newLine();

        const link = (0, _terminalLink().default)('expo.fyi/credentials-non-interactive', 'https://expo.fyi/credentials-non-interactive');
        (0, _log().default)(_chalk().default.bold.red(`Additional information needed to setup credentials in non-interactive mode.`));
        (0, _log().default)(_chalk().default.bold.red(`Learn more about how to resolve this: ${link}.`));

        _log().default.newLine(); // We don't want to display project credentials when we bail out due to
        // non-interactive mode error, because we are unable to recover without
        // user input.


        throw new (_CommandError().default)(_CommandError().ErrorCodes.NON_INTERACTIVE, 'Unable to proceed, see the above error message.');
      } else {
        (0, _log().default)(_chalk().default.bold.red('Failed to prepare all credentials. \nThe next time you build, we will automatically use the following configuration:'));
      }
    }

    const credentials = await context.ios.getAllCredentials();
    (0, _list().displayProjectCredentials)(experienceName, bundleIdentifier, credentials);
  }

  async produceCredentials(ctx, experienceName, bundleIdentifier) {
    const nonInteractive = this.options.parent && this.options.parent.nonInteractive;
    const appCredentials = await ctx.ios.getAppCredentials(experienceName, bundleIdentifier);

    if (ctx.hasAppleCtx()) {
      await apple().ensureAppExists(ctx.appleCtx, {
        experienceName,
        bundleIdentifier
      }, {
        enablePushNotifications: true
      });
    }

    const distCertFromParams = await (0, _IosDistCert().getDistCertFromParams)(this.options);

    if (distCertFromParams) {
      await (0, _IosDistCert().useDistCertFromParams)(ctx, appCredentials, distCertFromParams);
    } else {
      await (0, _route().runCredentialsManager)(ctx, new (_SetupIosDist().SetupIosDist)({
        experienceName,
        bundleIdentifier,
        nonInteractive
      }));
    }

    const distributionCert = await ctx.ios.getDistCert(experienceName, bundleIdentifier);

    if (!distributionCert) {
      throw new (_CommandError().default)('INSUFFICIENT_CREDENTIALS', `This build request requires a valid distribution certificate.`);
    }

    const pushKeyFromParams = await (0, _IosPushCredentials().getPushKeyFromParams)(this.options);

    if (pushKeyFromParams) {
      await (0, _IosPushCredentials().usePushKeyFromParams)(ctx, appCredentials, pushKeyFromParams);
    } else {
      await (0, _route().runCredentialsManager)(ctx, new (_SetupIosPush().SetupIosPush)({
        experienceName,
        bundleIdentifier,
        nonInteractive
      }));
    }

    const provisioningProfileFromParams = await (0, _IosProvisioningProfile().getProvisioningProfileFromParams)(this.options);

    if (provisioningProfileFromParams) {
      await (0, _IosProvisioningProfile().useProvisioningProfileFromParams)(ctx, appCredentials, this.options.teamId, provisioningProfileFromParams, distributionCert);
    } else {
      await (0, _route().runCredentialsManager)(ctx, new (_SetupIosProvisioningProfile().SetupIosProvisioningProfile)({
        experienceName,
        bundleIdentifier,
        distCert: distributionCert,
        nonInteractive
      }));
    }
  }

  async clearAndRevokeCredentialsIfRequested(ctx, projectMetadata) {
    const {
      clearCredentials,
      clearDistCert,
      clearPushKey,
      clearPushCert,
      clearProvisioningProfile
    } = this.options;
    const shouldClearAnything = clearCredentials || clearDistCert || clearPushKey || clearPushCert || clearProvisioningProfile;

    if (shouldClearAnything) {
      const {
        experienceName,
        bundleIdentifier
      } = projectMetadata;
      const credsToClear = this.determineCredentialsToClear();
      await this.clearCredentials(ctx, experienceName, bundleIdentifier, credsToClear);
    }
  }

  async clearCredentials(ctx, experienceName, bundleIdentifier, credsToClear) {
    const shouldRevokeOnApple = this.options.revokeCredentials;
    const nonInteractive = this.options.parent && this.options.parent.nonInteractive;
    const distributionCert = await ctx.ios.getDistCert(experienceName, bundleIdentifier);

    if (credsToClear.distributionCert && distributionCert) {
      await new (_IosDistCert().RemoveIosDist)(shouldRevokeOnApple, nonInteractive).removeSpecific(ctx, distributionCert);
    }

    const pushKey = await ctx.ios.getPushKey(experienceName, bundleIdentifier);

    if (credsToClear.pushKey && pushKey) {
      await new (_IosPushCredentials().RemoveIosPush)(shouldRevokeOnApple, nonInteractive).removeSpecific(ctx, pushKey);
    }

    const appCredentials = await ctx.ios.getAppCredentials(experienceName, bundleIdentifier);
    const provisioningProfile = await ctx.ios.getProvisioningProfile(experienceName, bundleIdentifier);

    if (credsToClear.provisioningProfile && provisioningProfile) {
      await new (_IosProvisioningProfile().RemoveProvisioningProfile)(shouldRevokeOnApple, nonInteractive).removeSpecific(ctx, appCredentials);
    }

    const pushCert = await ctx.ios.getPushCert(experienceName, bundleIdentifier);

    if (credsToClear.pushCert && pushCert) {
      await ctx.ios.deletePushCert(experienceName, bundleIdentifier);
    }
  }

  determineCredentialsToClear() {
    const {
      clearCredentials,
      clearDistCert,
      clearPushKey,
      clearPushCert,
      clearProvisioningProfile
    } = this.options;
    const credsToClearAll = {
      distributionCert: Boolean(clearCredentials || clearDistCert),
      pushKey: Boolean(clearCredentials || clearPushKey),
      // TODO: backward compatibility, remove when all users migrate to push keys
      pushCert: Boolean(clearCredentials || clearPushCert),
      provisioningProfile: Boolean(clearCredentials || clearProvisioningProfile)
    };
    return (0, _pickBy().default)(credsToClearAll);
  }

  async ensureProjectIsPublished() {
    if (this.options.publicUrl) {
      return undefined;
    } else {
      return await this.ensureReleaseExists();
    }
  }

  platform() {
    return _constants().PLATFORMS.IOS;
  } // validates whether the icon doesn't have transparency


  async validateIcon() {
    try {
      const icon = (0, _get().default)(this.manifest, 'ios.icon', this.manifest.icon);
      await (0, _image().ensurePNGIsNotTransparent)(icon);
    } catch (err) {
      if (err instanceof _xdl().XDLError) {
        throw err;
      } else {// something weird happened, let's assume the icon is correct
      }
    }
  }

}

var _default = IOSBuilder;
exports.default = _default;
//# sourceMappingURL=../../../__sourcemaps__/commands/build/ios/IOSBuilder.js.map
