"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CreateOrReuseProvisioningProfileAdhoc = void 0;

function _chalk() {
  const data = _interopRequireDefault(require("chalk"));

  _chalk = function () {
    return data;
  };

  return data;
}

function _provisioningProfileAdhoc() {
  const data = require("../../appleApi/provisioningProfileAdhoc");

  _provisioningProfileAdhoc = function () {
    return data;
  };

  return data;
}

function _log() {
  const data = _interopRequireDefault(require("../../log"));

  _log = function () {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class CreateOrReuseProvisioningProfileAdhoc {
  constructor(options) {
    _defineProperty(this, "_experienceName", void 0);

    _defineProperty(this, "_bundleIdentifier", void 0);

    _defineProperty(this, "_distCertSerialNumber", void 0);

    _defineProperty(this, "_udids", void 0);

    const {
      experienceName,
      bundleIdentifier,
      distCertSerialNumber,
      udids
    } = options;
    this._experienceName = experienceName;
    this._bundleIdentifier = bundleIdentifier;
    this._distCertSerialNumber = distCertSerialNumber;
    this._udids = udids;
  }

  async assignProvisioningProfile(ctx, provisioningProfile) {
    await ctx.ios.updateProvisioningProfile(this._experienceName, this._bundleIdentifier, provisioningProfile, ctx.appleCtx.team);
    (0, _log().default)(_chalk().default.green(`Successfully assigned Provisioning Profile id: ${provisioningProfile.provisioningProfileId} to ${this._experienceName} (${this._bundleIdentifier})`));
  }

  async createOrReuse(ctx) {
    await ctx.ensureAppleCtx();
    const ppManager = new (_provisioningProfileAdhoc().ProvisioningProfileAdhocManager)(ctx.appleCtx);
    return await ppManager.createOrReuse(this._udids, this._bundleIdentifier, this._distCertSerialNumber);
  }

  async open(ctx) {
    if (!ctx.user) {
      throw new Error(`This workflow requires you to be logged in.`);
    }

    const provisioningProfile = await this.createOrReuse(ctx);
    await this.assignProvisioningProfile(ctx, provisioningProfile);
    return null;
  }

}

exports.CreateOrReuseProvisioningProfileAdhoc = CreateOrReuseProvisioningProfileAdhoc;
//# sourceMappingURL=../../__sourcemaps__/credentials/views/IosProvisioningProfileAdhoc.js.map
